export declare class DirectFitting {
    private static FitNumeric;
    private static FitSingleon;
    private static FitInteger;
    private _customFitters;
    private _customFittables;
    private _nonfittables;
    constructor();
    /**
     * Two object are fittable if and only if none of them contain nonfittable property keys or they contain exactly same nonfittable property key and value.
     */
    IsFittable<T>(start: T, end: T): boolean;
    /**
     * Fit property with consideration of custom fittables.
    */
    private FitProperty;
    Fit(percentage: number, start: number, end: number): number;
    Fit<T>(percentage: number, start: T, end: T): T;
    Fit<T>(percentage: number, start: T[], end: T[]): T[];
    RegisterCustomFitter(key: string, fitter: (p: number, s: any, e: any) => any): void;
    RegisterCustomFittables(proeprty: string, fitterKey: string): void;
    RegisterNonFittables(property: string): void;
}
